#include <AltSoftSerial.h> // Better than old lib
#include <TinyGPS.h>
#include <SD.h> // Standard Arduino SD card library

File myFile;
const int buttonPin = 17; // Declare PIN 17 for charging control
int buttonState = 0;  // State button int

#define datawrite 15 // Write data from GPS
#define pin16 16  // Signal driving transistor for batt charger

TinyGPS gps;
AltSoftSerial nss; //use default pin for Teensy 2.0 check pjrc.com/teensy
char filename[] = "GPSLOG00.CSV";
boolean logg = true;

void setup() 
{
  //Serial.begin(57600);
  ADCSRA = 0;   // shut off ADC
  nss.begin(9600);
  nss.print("$PMTK251,9600*17"); //force 9600bps
  nss.print("$PMTK220,5000*1F"); //Set NMEA port update rate, 5sec
    
  pinMode(datawrite, OUTPUT);
  pinMode(pin16, OUTPUT);
  pinMode(buttonPin, INPUT_PULLUP); // Set input buttonpin & pull-up on analog pin 17
  
 // Initialize SD card
    pinMode(0, OUTPUT);
    if (!SD.begin(0)) 
    {
    logg = false;               //turns off if card not present
}
  if (logg==true)
  {                            // check SD   
    for (uint8_t i = 0; i < 100; i++) {
      filename[6] = i/10 + '0';
      filename[7] = i%10 + '0';
      if (! SD.exists(filename)) {                // open a new file if it doesn't exist        
        myFile = SD.open(filename, FILE_WRITE);  // Create a new file
  // At every power up, we create a new CSV file whith the fields bellow
  if (myFile) 
  {
    myFile.print("Latitude,");
    myFile.print("Longitude,");
    myFile.print("Speed,");
    myFile.print("Altitude,");
    myFile.print("Date,");
    myFile.println("Time");
    myFile.close();
    // Then, close it
        break;
      }
    }
  }
}
}

void loop() 
{
    buttonState = digitalRead(buttonPin); // Read button state
    if (buttonState == LOW) 
    {
    digitalWrite(pin16, HIGH); // Enabling charging mode to LTC4054
    } 
  
bool newdata = false;               // switch to 'true' argument to debug, you will see "blank" data
unsigned long start = millis();
while (millis() - start < 5000) {   // Update every 5 Secs
if (feedgps())
newdata = true;                     // switch to 'false' argument to debug, you will see "blank" data
}
if (newdata) 
{
gpsdump(gps);
}
}
// Get and process GPS data, Add/Remove what you want, see arduiniana.org/libraries/tinygps
void gpsdump(TinyGPS &gps) {
  
  float flat, flon;                  // Lat + Long
  float fkmph = gps.f_speed_kmph();  // speed in km/hr
  float falt = gps.f_altitude();    // +/- altitude in meters
  unsigned long age;
  int year;
  byte month, day, hour, minute, second;
  gps.crack_datetime(&year, &month, &day, &hour, &minute, &second);
  gps.f_get_position(&flat, &flon, &age);

  // And write it to SD card
  // if the file opened okay, write to it:
  myFile = SD.open(filename, FILE_WRITE);
  if (myFile) 
  {
    myFile.print(flat, 4); // latitude
    myFile.print(",");
    myFile.print(flon, 4); // longitude
    myFile.print(",");
    myFile.print(fkmph); // K/MS
    myFile.print(",");
    myFile.print(falt);  // Altitude
    myFile.print(",");   
    myFile.print(static_cast<int>(day));
    myFile.print(":");
    myFile.print(static_cast<int>(month)); 
    myFile.print(":"); 
    myFile.print(year);
    myFile.print(",");
    myFile.print(static_cast<int>(hour)); 
    myFile.print(":"); 
    myFile.print(static_cast<int>(minute)); 
    myFile.print(":"); 
    myFile.println(static_cast<int>(second));
    myFile.close();     // close the file:
    blinkled();  
}
  }
// Feed data as it becomes available 
bool feedgps()
{
  while (nss.available()) {
    if (gps.encode(nss.read()))
      return true;
      
  }
  return false;
}
// Blink a LED everytime a sentence has been writed
void blinkled()
{
    digitalWrite(datawrite, HIGH);
    delay(50);
    digitalWrite(datawrite, LOW);
    delay(50);
}
